<?php

require_once("binary.php");

$f=file_get_contents("PRINCE10.EX");

function parse_seq_addresses($f){
	$sa=0x1DE18;
	$ea=0x1DEFE;
	$entries=array();
	print "<h2>Sequence adresses</h2>";
	print "<table border='1'>\r\n";
	for($i=0,$p=$sa;$p<$ea;++$i){
		$ad=getint2($f,$p);
		$entries[$ad][]=$i;
		printf("<tr><td>%d</td><td>%s</td></tr>",$i,jump_addr($ad));
	}
	print "</table>\r\n";
	//print_r($entries);
	//die();
	return $entries;
}

function parse_frame_table($f,&$beg,&$cbase){
	$beg=0;
	$cbase=array(0=>401,1=>801,2=>851,3=>751);
	
	// select frame table here:
	$sa=0x1D570; $ea=0x1da25; // KID
	//$sa=0x1DA26; $ea=0x1Daf3; $beg=0x95; // guard
	//$sa=0x1daf4; $ea=0x1dca5; // PV: before level 3
	//$sa=0x1daf4; $ea=0x1dca5; $cbase[2]=901; // PV: after level 3
	
	$p=$sa;
	$tbl=array();
	$i=$beg;

	print "<h2>Frame table</h2>";
	print "<table border='1'>\r\n";
	while($p<$ea){
		$fimage=getint1($f,$p);
		$fsword=getint1($f,$p);
		$fdx=getint1($f,$p); if($fdx>>7) $fdx-=256;
		$fdy=getint1($f,$p); if($fdy>>7) $fdy-=256;
		$fcheck=getint1($f,$p);
		$item=list($fc,$fr,$fs,$fx,$fy,$foe,$ffl,$fth,$fxb)=array($fsword>>6,$fimage,$fsword&63,$fdx,$fdy,$fcheck>>7,$fcheck>>6&1,$fcheck>>5&1,$fcheck&15);
		printf("<tr><td>frame 0x%02X CHTABLE=%d IMAGE=%3d SWORD=%3d DX=%4d DY=%4d OE=%d FLOOR=%d THIN=%d XBASE=%2d</td><td><img src='KID.DAT/res%d.bmp'></td></tr>",
			$i,$fc,$fr,$fs,$fx,$fy,$foe,$ffl,$fth,$fxb,$fr+$cbase[$fc]);
		$tbl[]=$item;
		$i++;
	}
	print "</table>\r\n";
	return $tbl;
}

function label_addr($x){
	$s=sprintf("0x%04X",$x);
	return "<a name='".$s."'>".$s."</a>";
}

function jump_addr($x){
	$s=sprintf("0x%04X",$x);
	return "<a href='#".$s."'>".$s."</a>";
}


function parse_seq_table($f,$tbl,$entries,$beg,$cbase){
	$ac=array(0=>"stand",1=>"run/jump",2=>"hang/climb",3=>"in midair",4=>"in freefall",5=>"bumped",6=>"hang straight",7=>"turn");
	$so=array(0=>"sword",1=>"feet",3=>"drink",4=>"level complete");

	$base=0x1C590;
	
	$p=0x1DEFE;
	
	print "<h2>Sequence table</h2>";
	print "<table border='1'>\r\n";
	while($p<0x1E804){
		$ad=$p-$base;
		$p0=$p;
		$c=getint1($f,$p);
		if($c>=241){
			switch($c){
				case 255: $c=getint2($f,$p); $line="Jump ".jump_addr($c); break;
				case 254: $line="Flip"; break;
				case 253: $line="Up"; break;
				case 252: $line="Down"; break;
				case 251: $c=getint1($f,$p); $line="DX 0x".h2($c,2); break;
				case 250: $c=getint1($f,$p); $line="DY 0x".h2($c,2); break;
				case 249: $c=getint1($f,$p); $line="Action 0x".h2($c,2)." (".$ac[$c].")"; break;
				case 248: $dx=getint1($f,$p); $dy=getint1($f,$p); $line="Setfall DX=0x".h2($dx,2)." DY=0x".h2($dy,2); break;
				case 247: $c=getint2($f,$p); $line="Jump if slowfall ".jump_addr($c); break;
				case 246: $line="die"; break;
				case 245: $line="knock up"; break;
				case 244: $line="knock down"; break;
				case 243: $c=getint1($f,$p); $line="effect 0x".h2($c,2); break;
				case 242: $c=getint1($f,$p); $line="sound 0x".h2($c,2)." (".$so[$c].")"; break;
				case 241: $line="end level"; break;
				default: die("??? unknown command ".$c." at 0x".h2($p,4));
			}
		}else{
			$line="Frame 0x".h2($c,2)." ";
				list($fc,$fr,$fs,$fx,$fy,$foe,$ffl,$fth,$fxb)=$tbl[$c-$beg];
				$line.=sprintf("<img src='KID.DAT/res%d.bmp'>",$fr+$cbase[$fc]);
		}
		$curr_entries = @$entries[$ad];
		if($curr_entries){
			$curr_entries = "Sequence ".implode(", ",$curr_entries);
		} else {
			$curr_entries="";
		}
		printf("<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>\r\n",$curr_entries,label_addr($ad),str2hex(substr($f,$p0,$p-$p0)),$line);
	}
	print "</table>\r\n";
}

$entries = parse_seq_addresses($f);
$tbl = parse_frame_table($f,$beg,$cbase);
parse_seq_table($f,$tbl,$entries,$beg,$cbase);
